`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   10:56:42 01/17/2013
// Design Name:   usb_interface
// Module Name:   C:/E/Documents/academic/sidechannel/chipwhisperer/openadc/hdl/hdl/testbench/test_register_interface.v
// Project Name:  sasebo-w-unified-iseproject
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: usb_interface
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module test_register_interface;

	// Inputs
	reg reset_i;
	reg clk;
	reg cmdfifo_rxf;
	reg cmdfifo_txe;
	reg [7:0] cmdfifo_din;
	reg [7:0] status;
	reg fifo_empty;
	reg [7:0] fifo_data;
	reg [31:0] extclk_frequency;
	reg [8:0] phase_i;
	reg phase_done_i;
	reg [31:0] maxsamples_i;

	// Outputs
	wire reset_o;
	wire cmdfifo_rd;
	wire cmdfifo_wr;
	wire [7:0] cmdfifo_dout;
	wire cmdfifo_isout;
	wire [7:0] gain;
	wire hilow;
	wire fifo_rd_en;
	wire fifo_rd_clk;
	wire cmd_arm;
	wire trigger_mode;
	wire trigger_wait;
	wire [9:0] trigger_level;
	wire trigger_source;
	wire trigger_now;
	wire [31:0] trigger_offset;
	wire phase_clk_o;
	wire [8:0] phase_o;
	wire phase_ld_o;
	wire adc_clk_src_o;
	wire [31:0] maxsamples_o;

	// Instantiate the Unit Under Test (UUT)
	usb_interface uut (
		.reset_i(reset_i), 
		.reset_o(reset_o), 
		.clk(clk), 
		.cmdfifo_rxf(cmdfifo_rxf), 
		.cmdfifo_txe(cmdfifo_txe), 
		.cmdfifo_rd(cmdfifo_rd), 
		.cmdfifo_wr(cmdfifo_wr), 
		.cmdfifo_din(cmdfifo_din), 
		.cmdfifo_dout(cmdfifo_dout), 
		.cmdfifo_isout(cmdfifo_isout), 
		.gain(gain), 
		.hilow(hilow), 
		.status(status), 
		.fifo_empty(fifo_empty), 
		.fifo_data(fifo_data), 
		.fifo_rd_en(fifo_rd_en), 
		.fifo_rd_clk(fifo_rd_clk), 
		.cmd_arm(cmd_arm), 
		.trigger_mode(trigger_mode), 
		.trigger_wait(trigger_wait), 
		.trigger_level(trigger_level), 
		.trigger_source(trigger_source), 
		.trigger_now(trigger_now), 
		.trigger_offset(trigger_offset), 
		.extclk_frequency(extclk_frequency), 
		.phase_clk_o(phase_clk_o), 
		.phase_o(phase_o), 
		.phase_ld_o(phase_ld_o), 
		.phase_i(phase_i), 
		.phase_done_i(phase_done_i), 
		.adc_clk_src_o(adc_clk_src_o), 
		.maxsamples_o(maxsamples_o), 
		.maxsamples_i(maxsamples_i)
	);

	always
		#5 clk = !clk;

	initial begin
		// Initialize Inputs
		reset_i = 1;
		cmdfifo_rxf = 0;
		cmdfifo_txe = 1;
		cmdfifo_din = 0;
		status = 0;
		fifo_empty = 0;
		fifo_data = 0;
		extclk_frequency = 0;
		phase_i = 0;
		phase_done_i = 0;
		maxsamples_i = 0;
		clk = 0;

		// Wait 100 ns for global reset to finish
		#100;
        
		reset_i = 0;
		#50;
		
		//WRITE ONE
		cmdfifo_rxf = 1;
		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_din = 8'b11000100;
				
		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_din = 8'd1;
		cmdfifo_rxf = 1;		
		
		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_din = 8'd0;
		cmdfifo_rxf = 1;		

		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_din = 8'hAC;
		cmdfifo_rxf = 1;			
		
		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_rxf = 0;
		#4;
		
		//READ ONE
		cmdfifo_rxf = 1;
		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_din = 8'b10000100;
				
		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_din = 8'd1;
		cmdfifo_rxf = 1;		
		
		@(posedge clk) wait(cmdfifo_rd == 1'b1);
		cmdfifo_din = 8'd0;
		cmdfifo_rxf = 1;	
		@(posedge clk);
		cmdfifo_rxf = 0;
		wait(cmdfifo_wr == 1'b1);
		
		@(posedge clk) wait(cmdfifo_wr == 1'b1);
		cmdfifo_rxf = 0;

	end
	     
endmodule

